﻿/*
 * FCKeditor - The text editor for Internet - http://www.fckeditor.net
 * Copyright (C) 2003-2007 Frederico Caldeira Knabben
 *
 * == BEGIN LICENSE ==
 *
 * Licensed under the terms of any of the following licenses at your
 * choice:
 *
 *  - GNU General Public License Version 2 or later (the "GPL")
 *    http://www.gnu.org/licenses/gpl.html
 *
 *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
 *    http://www.gnu.org/licenses/lgpl.html
 *
 *  - Mozilla Public License Version 1.1 or later (the "MPL")
 *    http://www.mozilla.org/MPL/MPL-1.1.html
 *
 * == END LICENSE ==
 *
 * Dialog windows operations.
 */

var FCKDialog = 
{
	BaseZIndex : 10000,
	LastSelectionData : null,
	DialogStack : []
} ;

// This method opens a dialog window using the standard dialog template.
FCKDialog.OpenDialog = function( dialogName, dialogTitle, dialogPage, width, height, customValue, parentWindow, resizable )
{
	// Setup the dialog info.
	var oDialogInfo = new Object() ;
	oDialogInfo.Title = dialogTitle ;
	oDialogInfo.Page = dialogPage ;
	oDialogInfo.Editor = window ;
	oDialogInfo.CustomValue = customValue ;		// Optional
	oDialogInfo.SelectionData = null ;

	if ( FCKBrowserInfo.IsIE )
	{
		var oSel = FCK.ToolbarSet.CurrentInstance.EditorDocument.selection ;
		var bInvalidRange = false ;

		if ( !oSel )
			bInvalidRange = true ;

		var oRange = oSel.createRange() ;
		if ( !oRange )
			bInvalidRange = true ;
		if ( oRange.parentElement && oRange.parentElement().ownerDocument != FCK.ToolbarSet.CurrentInstance.EditorDocument )
			bInvalidRange = true ;
		if ( oRange.item && oRange.item(0).ownerDocument != FCK.ToolbarSet.CurrentInstance.EditorDocument )
			bInvalidRange = true ;

		if ( bInvalidRange )
			oDialogInfo.SelectionData = this.LastSelectionData ;
		else
		{
			oDialogInfo.SelectionData = oRange ;
			this.LastSelectionData = oRange ;
		}
	}

	var sUrl = FCKConfig.BasePath + 'fckdialog.html' ;
	this.Show( oDialogInfo, dialogName, sUrl, width, height, parentWindow, resizable ) ;
}

FCKDialog.Show = function( dialogInfo, dialogName, pageUrl, dialogWidth, dialogHeight, parentWindow, resizable )
{
	var ownerWindow = FCK.ToolbarSet.CurrentInstance.Window.parent ;
	var ownerDocument = ownerWindow.document ;
	var scrollTop = ownerDocument.body.scrollTop ;
	var scrollLeft = ownerDocument.body.scrollLeft ;
	var innerWidth = FCKBrowserInfo.IsIE ? ownerDocument.documentElement.offsetWidth : ownerWindow.innerWidth ;
	var innerHeight = FCKBrowserInfo.IsIE ? ownerDocument.documentElement.offsetHeight : ownerWindow.innerHeight ;
	var iTop  = Math.max( scrollTop + ( innerHeight - dialogHeight - 20 ) / 2, 0 ) ;
	var iLeft = Math.max( scrollLeft + ( innerWidth - dialogWidth - 20 )  / 2, 0 ) ;
	if ( ! ownerWindow.FCKDialogArguments )
		ownerWindow.FCKDialogArguments = {} ;
	var dialogId = parseInt( Math.random() * 0x10000000, 10 ) ;
	ownerWindow.FCKDialogArguments[dialogId] = dialogInfo ;
	
	var frame = ownerDocument.createElement( 'iframe' ) ;
	frame.id = dialogId ;
	frame.frameBorder = 0 ;
	frame.ownerWindow = ownerWindow ;
	FCKDomTools.SetElementStyles( frame, 
			{ 
				'position' : 'absolute',
				'top' : iTop + 'px',
				'left' : iLeft + 'px',
				'zIndex' : this.BaseZIndex += 100
			} ) ;
	ownerDocument.body.appendChild( frame ) ;
	this.ResizeDialog( frame, dialogWidth, dialogHeight ) ;

	// Assigning frame.src directly does not work in Opera 9.5, need to use a timeout trick
	var loadFrame = function()
	{
		frame.src = pageUrl + '#dialogId=' + dialogId ;
	}
	setTimeout( loadFrame, 0 ) ;

	var oWindow = frame.contentWindow ;
	oWindow.focus() ;
	this.Window = oWindow ;

	// Keep record of the current dialog in the dialog stack, and enable dialog mode
	// if this is the first dialog in the dialog stack.
	if ( this.DialogStack.length == 0 )
		FCK.ToolbarSet.CurrentInstance.SetDialogMode( true ) ;
	else
		this.SetEnabled( this.DialogStack[ this.DialogStack.length - 1 ], false );
	this.DialogStack.push( frame ) ;

	// Register drag handlers.
	this.InitDragHandlers( ownerWindow ) ;
}



// The following member functions should be called with a dialog frame element as subject.
FCKDialog.ResizeDialog = function( frame, width, height )
{
	FCKDomTools.SetElementStyles( frame,
		{
			'width' : width + 'px',
			'height' : height + 'px'
		} ) ;
}

FCKDialog.CloseDialog = function( frame )
{
	var ownerWindow = frame.ownerWindow ;
	var dialogId = frame.id ;
	delete ownerWindow.FCKDialogArguments[dialogId] ;
	frame.parentNode.removeChild( frame ) ;
	this.BaseZIndex -= 100 ;

	// Pop the dialog from the dialog stack, and disable dialog mode if the stack is empty.
	this.DialogStack.pop() ;
	if ( this.DialogStack.length == 0)
		FCK.ToolbarSet.CurrentInstance.SetDialogMode( false ) ;
	else
		this.SetEnabled( this.DialogStack[ this.DialogStack.length - 1 ], true ) ;

}

FCKDialog.SetEnabled = function( frame, yes )
{
}

;(function()
{
	var _dragDialog = null ;
	var _ownerWindow = null ;
	var _lastCoords = null ;

	FCKDialog._GetMouseCoordinates = function( evt )
	{
		var element = evt.srcElement || evt.target ;
		var view = element.ownerDocument.parentWindow || evt.view ;
		var retval = { 'x': evt.clientX, 'y': evt.clientY };
		if ( view != _ownerWindow )
		{
			var offset = FCKTools.GetDocumentPosition( _ownerWindow, element.ownerDocument.documentElement ) ;
			retval.x += offset.x ;
			retval.y += offset.y ;
		}
		return retval ;
	}

	FCKDialog._DragMouseDownHandler = function( evt )
	{
		var view = null ;
		if ( !evt )
		{
			view = this.ownerDocument.parentWindow ;
			evt = view.event ;
		}
		else
			view = evt.view ;

		_dragDialog = view.frameElement ;
		_lastCoords = FCKDialog._GetMouseCoordinates( evt ) ;

		if ( evt.preventDefault )
			evt.preventDefault() ;
		else
			evt.returnValue = false ;
	}

	FCKDialog._DragMouseMoveHandler = function( evt )
	{
		if ( !_dragDialog )
			return ;
		if ( !evt )
			evt = this.ownerDocument.parentWindow.event ;

		var currentCoords = FCKDialog._GetMouseCoordinates( evt );
		var dx = currentCoords.x - _lastCoords.x;
		var dy = currentCoords.y - _lastCoords.y;
		_lastCoords = currentCoords;

		var x = parseInt( FCKDomTools.GetCurrentElementStyle( _ownerWindow, _dragDialog, 'left' ) ) + dx ;
		var y = parseInt( FCKDomTools.GetCurrentElementStyle( _ownerWindow, _dragDialog, 'top' ) ) + dy ;
		FCKDomTools.SetElementStyles( _dragDialog, 
			{
				'left' : x + 'px',
				'top' : y + 'px'
			} ) ;

		if ( evt.preventDefault )
			evt.preventDefault() ;
		else
			evt.returnValue = false ;
	}

	FCKDialog._DragMouseUpHandler = function( evt )
	{
		if ( !_dragDialog )
			return ;
		if ( !evt )
			evt = this.ownerDocument.parentWindow.event ;
		_dragDialog = null ;
		_lastCoords = null ;
	}

	FCKDialog.RegisterDragHandlers = function( w )
	{
		if ( w._FCKDialogHandlersRegistered )
			return ;

		FCKTools.AddEventListener( w.document.documentElement, 'mousemove', this._DragMouseMoveHandler ) ;
		FCKTools.AddEventListener( w.document.documentElement, 'mouseup', this._DragMouseUpHandler ) ;
		w._FCKDialogHandlersRegistered = true ;
	}

	FCKDialog.InitDragHandlers = function( w )
	{
		if ( _ownerWindow )
			return ;
		_ownerWindow = w ;
		this.RegisterDragHandlers( w ) ;
	}
})() ;
